using System.Runtime.InteropServices;
using StoreKit;

NSApplication.Init();
NSApplication.SharedApplication.Delegate = new App();
NSApplication.Main(args);

[Register(nameof(App))]
sealed class App : NSApplicationDelegate
{
    public override void WillFinishLaunching(NSNotification notification)
    {
        var mwc = new NSWindowController(new NSWindow
        {
            TitleVisibility = NSWindowTitleVisibility.Hidden,
            ToolbarStyle = NSWindowToolbarStyle.Unified,
            TabbingMode = NSWindowTabbingMode.Disallowed,
            ContentViewController = new ViewController(),
            StyleMask = NSWindowStyle.Titled | NSWindowStyle.Closable | NSWindowStyle.Resizable | NSWindowStyle.Miniaturizable | NSWindowStyle.FullSizeContentView,
        });
        mwc.Window.SetContentSize(new CGSize(700, 500));
        mwc.Window.MakeKeyAndOrderFront(null);
    }
}

public class ViewController : NSViewController
{
    public ViewController()
    {
        var stack = new NSStackView();
        var btnA = new NSButton { Title = "does not work" };
        var btnB = new NSButton { Title = "works" };
        stack.AddArrangedSubview(btnA);
        stack.AddArrangedSubview(btnB);
        View = stack;

#pragma warning disable APL0004
        btnA.Activated += (sender, args) => AppStore.RequestReview(this);
        btnB.Activated += (sender, args) => _ = MyAppStore.RequestReview(Handle);
#pragma warning restore APL0004
    }
}

static class MyAppStore
{
    [DllImport("__Internal", EntryPoint = "RequestReview")]
    public static extern int RequestReview(IntPtr ui);
}